diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index 93292301d..0ecda8f7f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -13,6 +13,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
@@ -27,6 +28,7 @@ public class MobPig
 
     public List<WeightedRandomLootObject> burningMobDrops = new ArrayList<>();
     private final @NotNull MobAge age;
+    protected float speedProgress = 0f;
 
     public MobPig(World world)
     {
@@ -71,6 +73,79 @@ public class MobPig
         this.age.tick(this.world);
     }
 
+    @Override
+    protected void updateAI() {
+        if (passenger instanceof Player) {
+            target = null;
+            pathToEntity = null;
+
+            moveForward = 0f;
+            moveStrafing = 0f;
+
+            final float accel = MathHelper.lerp(3, 10f, speedProgress) * (!onGround ? 0.25f : 1f) * (isInWater() ? 0.5f : 1f);
+            final float maxSpeed = MathHelper.lerp(3, 10f, speedProgress) * (!(onGround || yd < 0) ? 0.25f : 1f) * (isInWater() ? 0.5f : 1f);
+
+            final double pXd = MathHelper.clamp(passenger.xd, -0.02, 0.02);
+            final double pZd = MathHelper.clamp(passenger.zd, -0.02, 0.02);
+
+            this.xd += pXd * accel;
+            this.zd += pZd * accel;
+            this.xd = MathHelper.clamp(this.xd, -maxSpeed, maxSpeed);
+            this.zd = MathHelper.clamp(this.zd, -maxSpeed, maxSpeed);
+
+            this.xRot = passenger.xRot;
+            this.yRot = passenger.yRot;
+            this.yBodyRot = passenger.yRot;
+
+            this.isJumping = isInWater() || ((Player) passenger).isJumping();
+
+            if ((onGround || yd < 0) && !isInWater() && !isJumping) {
+                if (pXd * pXd + pZd * pZd > 0.000005f) {
+                    speedProgress += 1/200f;
+                    speedProgress *= 1.025f;
+                } else {
+                    speedProgress *= 0.9f;
+                }
+                speedProgress = MathHelper.clamp(speedProgress, 0, 1);
+            } else {
+                speedProgress = 0f;
+            }
+        } else {
+            this.footSize = 0.5f;
+            super.updateAI();
+        }
+    }
+
+    @Override
+    public void positionRider() {
+        super.positionRider();
+        if (passenger instanceof Player) {
+            ((Player) passenger).yBodyRotO = this.yBodyRotO;
+            ((Player) passenger).yBodyRot = this.yBodyRot;
+            passenger.walkDist = this.walkDist;
+            passenger.walkDistO = this.walkDistO;
+
+
+            // The pig should probably not be the one setting up the view bobbing params
+            double velocity = MathHelper.sqrt(xd * xd + zd * zd);
+            double pitch = (float) Math.atan(-yd * 0.2D) * 15F;
+            if(velocity > 0.1F)
+            {
+                velocity = 0.1F;
+            }
+            if(!onGround || getHealth() <= 0)
+            {
+                velocity = 0.0F;
+            }
+            if(onGround || getHealth() <= 0)
+            {
+                pitch = 0.0F;
+            }
+            ((Player)passenger).cameraVelocity += (float) ((velocity - ((Player)passenger).cameraVelocity) * 0.4F);
+            ((Player)passenger).cameraPitch += (float) ((pitch - cameraPitch) * 0.8F);
+        }
+    }
+
     @Override
     public String getLivingSound()
     {
@@ -93,15 +168,31 @@ public class MobPig
 	public boolean interact(@NotNull Player player)
     {
         if (super.interact(player)) return true;
-        if (getSaddled() && !world.isClientSide && (passenger == null || passenger == player))
-        {
-            player.startRiding(this);
+        ItemStack heldItem = player.getHeldItem();
+        if (heldItem != null && (heldItem.itemID == Blocks.MUSHROOM_BROWN.id() || heldItem.itemID == Blocks.MUSHROOM_RED.id()) && heldItem.consumeItem(player)) {
+            heal(4);
             return true;
         }
-        else
-        {
-            return false;
+        if (!world.isClientSide) {
+            if (getSaddled()) {
+                if (player.isSneaking()) {
+                    if (passenger == null) {
+                        setSaddled(false);
+                        ItemStack toInsert = new ItemStack(Items.SADDLE);
+                        player.inventory.insertItem(toInsert, true);
+                        if (toInsert.stackSize > 0) {
+                            dropItem(toInsert, 0.0f);
+                        }
+                        return true;
+                    }
+                }
+                if (passenger == null || passenger == player) {
+                    player.startRiding(this);
+                    return true;
+                }
+            }
         }
+        return false;
     }
 
     @Override
@@ -150,10 +241,13 @@ public class MobPig
 	public void thunderHit(EntityLightning bolt)
     {
         if (!world.isClientSide) {
-            MobZombiePig entitypigzombie = new MobZombiePig(world);
-            entitypigzombie.moveTo(x, y, z, yRot, xRot);
-            world.entityJoinedWorld(entitypigzombie);
+            MobZombiePig pigZombie = new MobZombiePig(world);
+            pigZombie.moveTo(x, y, z, yRot, xRot);
+            world.entityJoinedWorld(pigZombie);
             remove();
+            if (passenger != null) {
+                passenger.startRiding(pigZombie);
+            }
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 8d227861f..e8d238d42 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -357,8 +357,6 @@ public abstract class Player
         double ydO = y;
         double zdO = z;
         super.rideTick();
-        cameraVelocityOld = cameraVelocity;
-        cameraVelocity = 0.0F;
         addMountedMovementStat(x - xdO, y - ydO, z - zdO);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java b/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java
index 58b40e401..004b0ef17 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java
@@ -16,12 +16,12 @@ public class ItemSaddle extends Item
     @Override
     public boolean useItemOnEntity(ItemStack itemstack, Mob mob, Player player)
     {
-        if(mob instanceof MobPig && itemstack.consumeItem(player))
+        if(!player.isSneaking() && mob instanceof MobPig && itemstack.consumeItem(player))
         {
-            MobPig entitypig = (MobPig) mob;
-            if(!entitypig.getSaddled())
+            MobPig pig = (MobPig) mob;
+            if(!pig.getSaddled())
             {
-                entitypig.setSaddled(true);
+                pig.setSaddled(true);
                 return true;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
index 8983428c0..d5a20ef39 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
@@ -42,10 +42,6 @@ public class MathHelper
         return d >= (double)truncated ? truncated : truncated - 1;
     }
 
-    public static int floorIntDiv(final int a, final int b) {
-        return floor((double) a / (double) b);
-    }
-
     public static int ceil(double d)
     {
         int truncated = (int)d;
@@ -113,6 +109,13 @@ public class MathHelper
     public static double lerp(double a, double b, double amount) {
         return a + ((b - a) * amount);
     }
+
+    public static float unlerp(float a, float b, float value) {
+        return (value - a)/(b - a);
+    }
+    public static double unlerp(double a, double b, double value) {
+        return (value - a)/(b - a);
+    }
 	
 	public static float getInterpolate(float[] array, float index) {
 		int index0 = (int) index;
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Side.java b/game/core/src/main/java/net/minecraft/core/util/helper/Side.java
index cc33de425..eb49332df 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Side.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/Side.java
@@ -101,7 +101,7 @@ public enum Side {
 		return opposite;
 	}
 	
-	public Direction getDirection() {
+	public @NotNull Direction getDirection() {
 		return direction;
 	}
 	
diff --git a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
index fb71c4755..5192a569d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -8,160 +8,238 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.season.SeasonManager;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Collection;
 import java.util.HashMap;
 import java.util.Map;
 
-public class BlocksContainer implements WorldSource {
-    public final World world;
-    private final Map<ChunkCoordinates, BlockEntry> blockEntryMap = new HashMap<>();
-    private Entity lightRefEntity = null;
-    public BlocksContainer(World world) {
+public class BlocksContainer implements MutableWorldSource {
+    public final @NotNull World world;
+    private final @NotNull Map<@NotNull TilePos, @NotNull BlockEntry> blockEntryMap = new HashMap<>();
+    private @Nullable Entity lightRefEntity = null;
+
+    public BlocksContainer(final @NotNull World world) {
         this.world = world;
     }
 
-    public void setLightReferenceEntity(Entity entity) {
+    @Override
+    public int getHeightBlocks() {
+        return this.world.getHeightBlocks();
+    }
+
+    public void setLightReferenceEntity(final @Nullable Entity entity) {
         this.lightRefEntity = entity;
     }
 
+    @Override
+    public boolean setBlockId(final @NotNull TilePos tilePos, final int id) {
+        this.blockEntryMap.put(tilePos, new BlockEntry(id, 0, null));
+        return true;
+    }
 
-    public void setBlock(int x, int y, int z, int blockID, int blockMeta, TileEntity entity) {
-        blockEntryMap.put(new ChunkCoordinates(x, y, z), new BlockEntry(blockID, blockMeta, entity, x, y, z));
+    @Deprecated
+    public void setBlock(final int x, final int y, final int z, final int id, final int data, final @Nullable TileEntity tileEntity) {
+        final @NotNull TilePos tilePos = new TilePos(x, y, z);
+
+        this.setBlockIdData(tilePos, id, data);
+        if (tileEntity != null) {
+            this.setTileEntity(tilePos, tileEntity);
+        }
     }
 
-    public BlockEntry getEntry(int x, int y, int z) {
-        return blockEntryMap.get(new ChunkCoordinates(x, y, z));
+    @Override
+    public boolean setBlockData(final @NotNull TilePos tilePos, final int data) {
+        final @Nullable BlockEntry entry = this.getEntry(tilePos);
+        if (entry != null) {
+            entry.data = data;
+        } else {
+            this.blockEntryMap.put(tilePos, new BlockEntry(this.world.getBlockId(tilePos), data, this.world.getTileEntity(tilePos)));
+        }
+
+        return true;
     }
 
-    public Collection<BlockEntry> getEntries() {
-        return blockEntryMap.values();
+    @Override
+    public boolean setBlockIdData(final @NotNull TilePos tilePos, final int id, final int data) {
+        this.blockEntryMap.put(tilePos, new BlockEntry(id, data, null));
+        return true;
     }
 
-    public void clear() {
-        blockEntryMap.clear();
+    @Override
+    public void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos, final int value) {
+        // Do nothing
+    }
+
+    @Override
+    public void setTileEntity(final @NotNull TilePos tilePos, final @NotNull TileEntity tileEntity) {
+        final @Nullable BlockEntry entry = this.getEntry(tilePos);
+        if (entry != null) {
+            entry.tileEntity = tileEntity;
+        } else {
+            this.blockEntryMap.put(tilePos, new BlockEntry(this.world.getBlockId(tilePos), this.world.getBlockData(tilePos), tileEntity));
+        }
+    }
+
+    @Override
+    public void removeTileEntity(final @NotNull TilePos tilePos) {
+        final @Nullable BlockEntry entry = this.getEntry(tilePos);
+        if (entry != null) {
+            entry.tileEntity = null;
+        } else {
+            this.blockEntryMap.put(tilePos, new BlockEntry(this.world.getBlockId(tilePos), this.world.getBlockData(tilePos), null));
+        }
+    }
+
+    public @Nullable BlockEntry getEntry(final @NotNull TilePos tilePos) {
+        return this.blockEntryMap.get(tilePos);
     }
 
+    @Deprecated
+    public @Nullable BlockEntry getEntry(final int x, final int y, final int z) {
+        return this.getEntry(new TilePos(x, y, z));
+    }
+
+    public @NotNull Collection<@NotNull BlockEntry> getEntries() {
+        return this.blockEntryMap.values();
+    }
+
+    public void clear() {
+        this.blockEntryMap.clear();
+    }
 
     @Override
-    public int getBlockId(int x, int y, int z) {
-        ChunkCoordinates c = new ChunkCoordinates(x, y, z);
-        if (blockEntryMap.containsKey(c)){
-            return blockEntryMap.get(c).blockID;
+    public int getBlockId(final @NotNull TilePos tilePos) {
+        final @Nullable BlockEntry entry = this.getEntry(tilePos);
+        if (entry != null) {
+            return entry.id;
         }
-        return world.getBlockId(x, y, z);
+
+        return this.world.getBlockId(tilePos);
     }
 
     @Override
-    public @Nullable Block<?> getBlock(int x, int y, int z) {
-        return Blocks.getBlock(getBlockId(x, y, z));
+    public @Nullable Block<?> getBlock(final @NotNull TilePos tilePos) {
+        return Blocks.getBlock(this.getBlockId(tilePos));
     }
 
     @Override
-    public TileEntity getTileEntity(int x, int y, int z) {
-        ChunkCoordinates c = new ChunkCoordinates(x, y, z);
-        if (blockEntryMap.containsKey(c)){
-            return blockEntryMap.get(c).tileEntity;
+    public @Nullable TileEntity getTileEntity(final @NotNull TilePos tilePos) {
+        final @Nullable BlockEntry entry = this.getEntry(tilePos);
+        if (entry != null) {
+            return entry.tileEntity;
         }
-        return world.getTileEntity(x, y, z);
+
+        return this.world.getTileEntity(tilePos);
     }
 
     @Override
-    public float getBrightness(int x, int y, int z, int blockLightValue) {
-        if (lightRefEntity != null) return lightRefEntity.getBrightness(1f);
-        return world.getBrightness(x, y, z, blockLightValue);
+    public float getBrightness(final @NotNull TilePos tilePos, final int lightEmission) {
+        if (this.lightRefEntity != null) {
+            return this.lightRefEntity.getBrightness(1.0f);
+        }
+
+        return this.world.getBrightness(tilePos, lightEmission);
+    }
+
+    @Override
+    public int getLightmapCoord(final @NotNull TilePos tilePos, final int lightEmission) {
+        if (this.lightRefEntity != null) {
+            return this.lightRefEntity.getLightmapCoord(1.0f);
+        }
+
+        return this.world.getLightmapCoord(tilePos, lightEmission);
     }
 
     @Override
-    public int getLightmapCoord(int x, int y, int z, int blockLightValue) {
-        if (lightRefEntity != null) return lightRefEntity.getLightmapCoord(1f);
-        return world.getLightmapCoord(x, y, z, blockLightValue);
+    public int getLightmapCoord(final int skyLight, final int blockLight) {
+        return this.world.getLightmapCoord(skyLight, blockLight);
     }
 
     @Override
-    public int getLightmapCoord(int skylight, int blocklight) {
-        return world.getLightmapCoord(skylight, blocklight);
+    public float getLightBrightness(final @NotNull TilePos tilePos) {
+        return this.world.getLightBrightness(tilePos);
     }
 
     @Override
-    public float getLightBrightness(int x, int y, int z) {
-        return world.getLightBrightness(x, y, z);
+    public int getBlockData(final @NotNull TilePos tilePos) {
+        final @Nullable BlockEntry entry = this.getEntry(tilePos);
+        if (entry != null) {
+            return entry.data;
+        }
+
+        return this.world.getBlockData(tilePos);
     }
 
     @Override
-    public int getBlockMetadata(int x, int y, int z) {
-        ChunkCoordinates c = new ChunkCoordinates(x, y, z);
-        if (blockEntryMap.containsKey(c)){
-            return blockEntryMap.get(c).blockMeta;
+    public @NotNull Material getBlockMaterial(final @NotNull TilePos tilePos) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        if (block == null) {
+            return Material.air;
+        } else {
+            return block.getMaterial();
         }
-        return world.getBlockMetadata(x, y, z);
     }
 
     @Override
-    public Material getBlockMaterial(int x, int y, int z) {
-        Block<?> b = getBlock(x, y, z);
-        return b == null ? Material.air : b.getMaterial();
+    public boolean isBlockOpaqueCube(final @NotNull TilePos tilePos) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        return block != null && block.isSolidRender();
     }
 
     @Override
-    public boolean isBlockOpaqueCube(int x, int y, int z) {
-        Block<?> b = getBlock(x, y, z);
-        return b != null && b.isSolidRender();
+    public boolean isBlockNormalCube(final @NotNull TilePos tilePos) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos.x, tilePos.y, tilePos.z);
     }
 
     @Override
-    public boolean isBlockNormalCube(int x, int y, int z) {
-        Block<?> b = getBlock(x, y, z);
-        return b != null && b.getMaterial().isSolidBlocking() && b.renderAsNormalBlockOnCondition(this, x, y, z);
+    public double getBlockTemperature(final @NotNull TilePos tilePos) {
+        return this.world.getBlockTemperature(tilePos);
     }
 
     @Override
-    public double getBlockTemperature(int x, int z) {
-        return world.getBlockTemperature(x, z);
+    public double getBlockHumidity(final @NotNull TilePos tilePos) {
+        return this.world.getBlockHumidity(tilePos);
     }
 
     @Override
-    public double getBlockHumidity(int x, int z) {
-        return world.getBlockHumidity(x, z);
+    public double getBlockVariety(final @NotNull TilePos tilePos) {
+        return this.world.getBlockVariety(tilePos);
     }
 
     @Override
-    public SeasonManager getSeasonManager() {
-        return world.getSeasonManager();
+    public @NotNull SeasonManager getSeasonManager() {
+        return this.world.getSeasonManager();
     }
 
     @Override
-    public Biome getBlockBiome(int x, int y, int z) {
-        return world.getBlockBiome(x, y, z);
+    public @NotNull Biome getBlockBiome(final @NotNull TilePos tilePos) {
+        return this.world.getBlockBiome(tilePos);
     }
 
     @Override
-    public int getSavedLightValue(LightLayer layer, int x, int y, int z) {
-        return world.getSavedLightValue(layer, x, y, z);
+    public int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos) {
+        return this.world.getSavedLightValue(lightLayer, tilePos);
     }
 
     @Override
     public boolean isRetro() {
-        return world.isRetro();
+        return this.world.isRetro();
     }
 
     public static class BlockEntry {
-        public final int blockID;
-        public final int blockMeta;
-        @Nullable
-        public final TileEntity tileEntity;
-        public final int x;
-        public final int y;
-        public final int z;
-        public BlockEntry(int blockID, int blockMeta, @Nullable TileEntity tileEntity, int x, int y, int z){
-            this.blockID = blockID;
-            this.blockMeta = blockMeta;
+        public int id;
+        public int data;
+        public @Nullable TileEntity tileEntity;
+
+        public BlockEntry(final int id, final int data, final @Nullable TileEntity tileEntity) {
+            this.id = id;
+            this.data = data;
             this.tileEntity = tileEntity;
-            this.x = x;
-            this.y = y;
-            this.z = z;
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java b/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java
new file mode 100644
index 000000000..0d8597a8a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java
@@ -0,0 +1,62 @@
+package net.minecraft.core.world;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+
+public interface MutableWorldSource
+    extends WorldSource {
+
+    boolean setBlockId(final @NotNull TilePos tilePos, final int id);
+
+    @Deprecated
+    default boolean setBlock(final int x, final int y, final int z, final int id) {
+        return this.setBlockId(new TilePos(x, y, z), id);
+    }
+
+    boolean setBlockData(final @NotNull TilePos tilePos, final int data);
+
+    @Deprecated
+    default boolean setBlockMetadata(final int x, final int y, final int z, final int data) {
+        return this.setBlockData(new TilePos(x, y, z), data);
+    }
+
+    boolean setBlockIdData(final @NotNull TilePos tilePos, final int id, final int data);
+
+    @Deprecated
+    default boolean setBlockAndMetadata(final int x, final int y, final int z, final int id, final int data) {
+        return this.setBlockIdData(new TilePos(x, y, z), id, data);
+    }
+
+    void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos, final int value);
+
+    @Deprecated
+    default void setLightValue(final @NotNull LightLayer lightLayer, final int x, final int y, final int z, final int value) {
+        this.setLightValue(lightLayer, new TilePos(x, y, z), value);
+    }
+
+    void setTileEntity(final @NotNull TilePos tilePos, final @NotNull TileEntity tileEntity);
+
+    @Deprecated
+    default void setTileEntity(final int x, final int y, final int z, final @NotNull TileEntity tileEntity) {
+        this.setTileEntity(new TilePos(x, y, z), tileEntity);
+    }
+
+    void removeTileEntity(final @NotNull TilePos tilePos);
+
+    @Deprecated
+    default void removeBlockTileEntity(final int x, final int y, final int z) {
+        this.removeTileEntity(new TilePos(x, y, z));
+    }
+
+    default void replaceTileEntity(final @NotNull TilePos tilePos, final @NotNull TileEntity tileEntity) {
+        this.removeTileEntity(tilePos);
+        this.setTileEntity(tilePos, tileEntity);
+    }
+
+    @Deprecated
+    default void replaceBlockTileEntity(final int x, final int y, final int z, final @NotNull TileEntity tileEntity) {
+        this.replaceTileEntity(new TilePos(x, y, z), tileEntity);
+    }
+}
